Attribute VB_Name = "AddIn"

Public canceled%

Declare Function WritePrivateProfileString& Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal AppName$, ByVal KeyName$, ByVal keydefault$, ByVal FileName$)

Public Const LVM_FIRST = &H1000
Public Const LVM_SETEXTENDEDLISTVIEWSTYLE = LVM_FIRST + 54
Public Const LVS_EX_FULLROWSELECT = &H20
Public Declare Function SendMessageLong Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal lMsg As Long, ByVal wParam As Long, lParam As Long) As Long

'====================================================================
'Diese Prozedur sollte vom Direktfenster aus ausgefhrt werden
'    damit diese Amwendung korrekt zu VBADDIN.INI hinzugefgt wird,
'    mssen Sie den Namen im zweiten Argument entsprechend dem
'    Projektnamen anpassen.
'====================================================================
Sub Main()
If Len(Command$) = 0 Then
   WritePrivateProfileString "Add-Ins32", "VbTestAddIn.Connect", "0", "vbaddin.ini"
   MsgBox "Das Add-In wurde erfolgreich registriert.", 64, "basicpro VB-Test"
Else
   '"-Embedding"
End If
End Sub

Function parse$(a$, ch$)
Dim ai&

ai& = InStr(a$, ch$)
If ai& = 0 Then
  parse$ = a$: a$ = ""
Else
  parse$ = Left$(a$, ai& - 1): a$ = Mid$(a$, ai& + Len(ch$))
End If

End Function

Sub ersetze(a$, ByVal a1$, ByVal a2$)
Dim pos%
pos% = 1
Do
   pos% = InStr(pos%, a$, a1$): If pos% = 0 Then Exit Do
   a$ = Left$(a$, pos% - 1) + a2$ + Mid$(a$, pos% + Len(a1$))
   pos% = pos% + Len(a2$)
Loop
End Sub

Function InStr_Word(ByVal pos%, a$, S$) As Integer
Dim i%, x$

Do
   i% = InStr_Ex(pos%, a$, S$): If i% = 0 Then Exit Do
   pos% = i% + 1
   If i% > 1 Then
      x$ = Mid$(a$, i% - 1, 1)
      If (x$ >= "A" And x$ <= "Z") Or (x$ >= "a" And x$ <= "z") Or (x$ >= "0" And x$ <= "9") Or x$ = "_" Then i% = 0
   End If
   If i% > 0 And i% + Len(S$) <= Len(a$) Then
      x$ = Mid$(a$, i% + Len(S$), 1)
      If (x$ >= "A" And x$ <= "Z") Or (x$ >= "a" And x$ <= "z") Or (x$ >= "0" And x$ <= "9") Or x$ = "_" Then i% = 0
   End If
Loop Until i% > 0
   
InStr_Word = i%

End Function

Function InStr_Ex(ByVal ab%, a$, b$) As Integer
Dim t%, pos%, z%

'Erweiterte InStr-Funktion:
'Fundstellen innerhalb "..." werden nicht bercksichtigt

t% = ab% - 1
Do
   t% = InStr(t% + 1, a$, b$): If t% = 0 Then Exit Do

   z% = 0: pos% = ab% - 1
   Do
      pos% = InStr(pos% + 1, a$, Chr$(34))
      If pos% = 0 Or pos% >= t% Then Exit Do
      z% = z% + 1
   Loop
   'in z% sind jetzt die Anzahl " zwischen ab% und t%-1

Loop While z% Mod 2

InStr_Ex = t%

End Function

Public Sub ListView_SetValue(LV As ListView, txt$, clmn1$, clmn$, value$)

SubIndex% = 0
For n% = 1 To LV.ColumnHeaders.Count
   If LV.ColumnHeaders(n%).Text = clmn$ Then SubIndex% = n%: Exit For
Next
If SubIndex% = 0 Then Exit Sub

For n% = 1 To LV.ListItems.Count
   If LV.ListItems(n%).Text = txt$ And (clmn1$ = LCase$(LV.ListItems(n%).SubItems(1)) Or clmn1$ = "*") Then
      LV.ListItems(n%).SubItems(SubIndex% - 1) = value$
      Exit For
   End If
Next

End Sub

Sub ListView_SetzeKopf(LV As ListView, a$)

On Error Resume Next
If LV.Sorted = True Then
   LV.SortKey = 0
   LV.SortOrder = 0
   LV.Sorted = True
End If
LV.Sorted = False
LV.SortOrder = 0
On Error GoTo 0

LV.ColumnHeaders.Clear: w& = 0
Do While Len(a$)
   a1$ = parse$(a$, ",")
   a2$ = parse$(a$, ",")
   If a2$ = "*" Then
      If LV.Width - 375 - w& < 0 Then a2$ = "1000" Else a2$ = LV.Width - 375 - w&
   Else
      w& = w& + Val(a2$) + 290
   End If
   Set clmX = LV.ColumnHeaders.Add(, , a1$, Val(a2$))
   clmX.Alignment = -1 * (UCase$(Right$(a2$, 1)) = "R")
Loop
'Freeze 0

LV.View = lvwReport
LV.ListItems.Clear

SendMessageLong LV.hwnd, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_FULLROWSELECT, ByVal True
LV.Refresh

End Sub

Sub ListView_Sort(LV As ListView, ColumnHeader As ComctlLib.ColumnHeader)

Screen.MousePointer = 11
If LV.Sorted = True And LV.SortKey = ColumnHeader.Index - 1 Then
   LV.SortOrder = 1 - LV.SortOrder
Else
   LV.SortKey = ColumnHeader.Index - 1
   LV.SortOrder = 0
End If

If ColumnHeader.Alignment = 1 Then
   laenge% = 0
   For n& = 1 To LV.ListItems.Count
      If ColumnHeader.Index = 1 Then
         laenge% = maxi%(laenge%, Len(LV.ListItems(n&).Text))
      Else
         laenge% = maxi%(laenge%, Len(LV.ListItems(n&).SubItems(ColumnHeader.Index - 1)))
      End If
   Next
   For n& = 1 To LV.ListItems.Count
      If ColumnHeader.Index = 1 Then
         LV.ListItems(n&).Text = Space$(laenge% - Len(LV.ListItems(n&).Text)) + LV.ListItems(n&).Text
      Else
         LV.ListItems(n&).SubItems(ColumnHeader.Index - 1) = Space$(laenge% - Len(LV.ListItems(n&).SubItems(ColumnHeader.Index - 1))) + LV.ListItems(n&).SubItems(ColumnHeader.Index - 1)
      End If
   Next
End If

LV.Sorted = True

If ColumnHeader.Alignment = 1 Then
   For n& = 1 To LV.ListItems.Count
      If ColumnHeader.Index = 1 Then
         LV.ListItems(n&).Text = Trim$(LV.ListItems(n&).Text)
      Else
         LV.ListItems(n&).SubItems(ColumnHeader.Index - 1) = Trim$(LV.ListItems(n&).SubItems(ColumnHeader.Index - 1))
      End If
   Next
End If
Screen.MousePointer = 0

End Sub

Function ListView_AddItem(LV As ListView, ByVal a$) As ListItem

Set itmX = LV.ListItems.Add(, , parse$(a$, Chr$(9)))

n% = 1
Do While Len(a$)
   itmX.SubItems(n%) = parse$(a$, Chr$(9))
   n% = n% + 1
Loop

Set ListView_AddItem = itmX

End Function

Private Function maxi%(a1%, a2%)

maxi% = IIf(a1% > a2%, a1%, a2%)

End Function

